## mympd 22.1.2

=== debian/changelog ===
mympd (22.1.2-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Sun, 19 Oct 2025 22:10:28 +0200
