=== debian/control ===
Source: mympd
Section: sound
Priority: optional
Maintainer: Juergen Mang <mail@jcgames.de>
Build-Depends: debhelper (>= 10),
               cmake,
               debhelper-compat (= 13),
               perl,
               gzip,
               jq,
               libssl-dev,
               libid3tag0-dev,
               libflac-dev,
               liblua5.4-dev | liblua5.3-dev,
               lua5.4 | lua5.3,
               libpcre2-dev
Standards-Version: 4.1.2
Homepage: https://jcorporation.github.io/myMPD/

Package: mympd
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         whiptail
Description: Standalone and mobile friendly web-based MPD client.
 myMPD is a standalone and lightweight web-based MPD client. It's tuned for
 minimal resource usage and requires only very few dependencies.
 Therefore myMPD is ideal for raspberry pis and similar devices.
