=== debian/changelog ===
mympd (23.0.0-1) unstable; urgency=medium

  * Release from master

 -- Juergen Mang <mail@jcgames.de>  Sun, 09 Nov 2025 15:11:21 +0100
